Summary:         A Modern Linker
Name:            mold
Version:         1.7.1
Release:         3%{?dist}
License:         AGPL-3.0-or-later AND (Apache-2.0 OR MIT)
URL:             https://github.com/rui314/mold
Source0:         %{url}/archive/v%{version}/%{name}-%{version}.tar.gz

Patch0001:       Fix-out-of-bounds-error-on-aarch64-with-_GLIBCXX_ASS.patch
Patch3000:       tbb-strip-werror.patch
Patch3001:       Use-system-compatible-include-path-for-xxhash.h.patch

BuildRequires:   cmake gcc gcc-c++ >= 10
BuildRequires:   libzstd-devel mimalloc-devel openssl-devel xxhash-devel zlib-devel hwloc-devel
BuildRequires:   clang gdb glibc-static libdwarf-tools libstdc++-static llvm
%ifarch x86_64
BuildRequires:   /usr/lib64/libc.so
%endif

Requires(post):  %{_sbindir}/alternatives
Requires(preun): %{_sbindir}/alternatives

Provides:	bundled(tbb) = 2021.5

%description
mold is a faster drop-in replacement for existing Unix linkers.
It is several times faster than the LLVM lld linker.
mold is designed to increase developer productivity by reducing
build time, especially in rapid debug-edit-rebuild cycles.

%prep
%autosetup -p1
rm -r third-party/{mimalloc,xxhash,zlib,zstd}

%build
%cmake -DMOLD_USE_SYSTEM_MIMALLOC=ON
%cmake_build

%install
%cmake_install

%post
if [ "$1" = 1 ]; then
  %{_sbindir}/alternatives --install %{_bindir}/ld ld %{_bindir}/ld.mold 1
fi

%postun
if [ "$1" = 0 ]; then
  %{_sbindir}/alternatives --remove ld %{_bindir}/ld.mold
fi

%check
%ctest

%files
%license %{_docdir}/mold/LICENSE
%ghost %{_bindir}/ld
%{_bindir}/mold
%{_bindir}/ld.mold
%{_bindir}/ld64.mold
%{_libdir}/mold/mold-wrapper.so
%{_libexecdir}/mold/ld
%{_mandir}/man1/ld.mold.1*
%{_mandir}/man1/mold.1*

%changelog
* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.7.1-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.7.1-2
- Rebuilt for OpenCloudOS Stream 23

* Sat Dec 17 2022 Miaojun Dong <zoedong@tencent.com> - 1.7.1-1
- initial build
